package com.mortals.xhx.common.pdu.flow;

import com.mortals.xhx.feign.AttachmentEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 工作流任务
 *
 * @author: finegirl
 * @date: 2021/7/31 23:38
 */
@Getter
@Setter
public class FlowTaskPdu implements Serializable {
    /**
     * 任务编号
     */
    private String taskId;

    /**
     * 任务名称
     */
    private String taskName;

    /**
     * 是否为子任务,0否 1是
     */
    private Integer subTask=0;

    /**
     * 表单名称
     */
    private String formName;

    /**
     * 父任务编号
     */
    private String parentTaskId;

    /**
     * 业务系统key
     */
    private String businessKey;

    /**
     * 任务Key
     */
    private String taskDefKey;

    /**
     * 任务执行人Id
     */
    private String assigneeId;
    /**
     * 部门名称
     */
    private String deptName;

    /**
     * 流程发起人部门名称
     */
    private String startDeptName;

    /**
     * 任务执行人名称
     */
    private String assigneeName;

    /**
     * 流程发起人Id
     */
    private String startUserId;

    /**
     * 流程发起人名称
     */
    private String startUserName;

    /**
     * 流程类型
     */
    private String category;

    /**
     * 流程变量信息
     */
    private Object procVars;

    /**
     * 局部变量信息
     */
    private Object taskLocalVars;

    /**
     * 流程部署编号
     */
    private String deployId;

    /**
     * 流程ID
     */
    private String procDefId;

    /**
     * 流程key
     */
    private String procDefKey;

    /**
     * 流程定义名称
     */
    private String procDefName;

    /**
     * 流程定义内置使用版本
     */
    private int procDefVersion;

    /**
     * 流程实例ID
     */
    private String procInsId;

    /**
     * 历史流程实例ID
     */
    private String hisProcInsId;

    /**
     * 任务耗时
     */
    private String duration;

    /**
     * 任务意见
     */
    private FlowCommentPdu comment;

    /**
     * 候选执行人
     */
    private String candidate;

    /**
     * 任务创建时间
     */
    //@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    /**
     * 任务完成时间
     */
    //@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date finishTime;

    /**
     * 流程变量信息
     */
    private Map<String, Object> values;

    /**
     * 附件信息
     */
    private List<AttachmentEntity> attachmentList;

    /**
     * 用户名称
     */
    private String userCode;

    /**
     * 审批人
     */
    private String assignee;

    /**
     * 候选人
     */
    private List<String> candidateUsers;

    /**
     * 审批组
     */
    private List<String> candidateGroups;

    /**
     * 业务平台标识
     */
    private String platformSn;


    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 项目编号
     */
    private String projectCode;

    /**
     * 委托人
     */
    private String procurementAgentAndPrincipal;

}
